-- file id = chatbot.cb_mem (chat-bot-memory)


-- paste at server.lua
-- dofile("sys/lua/chat_bot_by_5783.lua")

-- init var/table
if chatbot == nil then chatbot = {} end
chatbot.read = {}
chatbot.write = {}
chatbot.word = {}
chatbot.answer = ""
-- settings
chatbot.max_wrong = 0.01 -- sentence recognized rate **
chatbot.version = "0.0.2.1" -- version number *
chatbot.cb_name = "[B.Sheep.:T.K:.]Gunz FBI" -- name (in chat)
chatbot.cb_memory_file = "sys/lua/chatbot_memory.dat" -- memory file
chatbot.random_say = true -- chatbot automaticly randomly says random words
chatbot.random_time = 7 -- how often random words apper (seconds)
chatbot.random_add = 7 -- random plus minus on chatbot.random_time (seconds)
-- * do NOT change
-- ** not recommended to change


function create_chatbot_memfile ()
chatbot.cb_mem = io.open (chatbot.cb_memory_file,"a")
chatbot.cb_mem:close()
end

function read_chatbot_memfile ()
chatbot.cb_mem = io.open (chatbot.cb_memory_file,"r")
i = 0
while (true) do
i = i + 1
data = chatbot.cb_mem:read()
if data == nil then break end
chatbot.read[i] = data
chatbot.write[i] = chatbot.cb_mem:read()
end
chatbot.cb_mem:close()
end


--init (function)
create_chatbot_memfile ()
read_chatbot_memfile ()



addhook("minute","chatbot_save_now")
function chatbot_save_now()
chatbot.cb_mem = io.open (chatbot.cb_memory_file,"w")
if chatbot.cb_mem == nil then
print ("error saving "..chatbot.cb_name.."s memory")
else
i = 0
while (i < #chatbot.write) do
i = i + 1
if (chatbot.write[i] == nil) == false then
chatbot.cb_mem:write(""..chatbot.read[i].."\n")
chatbot.cb_mem:write(""..chatbot.write[i].."\n")
end
end
chatbot.cb_mem:close()
end
end

-- improved function
function string.comp(str1, str2) -- by dark byte
     local min = math.max(str1:len(), str2:len())
     local err = 0
     for i = 1, min do
          local s1 = str1:sub(i,i) or 0
          local s2 = str2:sub(i,i) or 0
          if ( s1 ~= s2 ) then
               err = err + 1
          end
     end
	 if err < (min*chatbot.max_wrong) then
		return err
	 else
		return 10000
	 end
end

addhook("say","chatbot_say_read")
function chatbot_say_read (id,text)
	if text == "!cb_info" then
		msg("chatbot (VERSION: "..chatbot.version..") knows "..#chatbot.read.." answer")
		return 0
	end
	if text == "!cb_credit" then
		msg("chatbot  magnus, 2011-2011")
		msg("created by magnus (usgn id: 5783)")
		msg("function string.comp by Dark Byte (usgn id: 13445)")
		return 0
	end
	if (chatbot.answer == "") == false then
		chatbot.read[#chatbot.read+1] = chatbot.answer
		chatbot.write[#chatbot.write+1] = text
		chatbot.answer = ""
		print(''..chatbot.cb_name..': "'..chatbot.read[#chatbot.read]..'" >>> "'..chatbot.write[#chatbot.write]..'"')
	end
	cb_best_match = 10
	cb_best_match_id = 0
	ii = 0
	while (ii < #chatbot.read) do
		ii = ii + 1
		if string.lower(text) == string.lower(chatbot.read[ii]) then
			cb_best_match_id = ii
			--print ('"'..text..'" is same as "'..chatbot.read[ii]..'"! *found')
			break
		end
		dif = string.comp (string.lower(text),string.lower(chatbot.read[ii]))
		if dif <= cb_best_match then
			--print ('"'..text..'" is same as "'..chatbot.read[ii]..'"? ('..dif..')')
			cb_best_match = dif
			cb_best_match_id = ii
		end
	end
	if cb_best_match_id == 0 then
		chatbot.answer = text
	else
		write_text = chatbot.write[cb_best_match_id]
		timer(math.random(string.len(write_text)*50,string.len(write_text)*100),"cb_sayanswer",write_text)
	end
end

chatbot.random_time = chatbot.random_time* 1000
chatbot.random_add = chatbot.random_add* 1000

if chatbot.random_say == true then
	timer(chatbot.random_time+math.random(-chatbot.random_add,chatbot.random_add),"bot_random_word")
end

function bot_random_word()
	timer(chatbot.random_time+math.random(-chatbot.random_add,chatbot.random_add),"bot_random_word")
	write_text = "hi"
	if math.random(2) == 1 then
		if #chatbot.read > 0 then
			write_text = chatbot.read[math.random(#chatbot.read)]
		end
	else
		if #chatbot.write > 0 then
			write_text = chatbot.write[math.random(#chatbot.write)]
		end
	end
	timer(math.random(string.len(write_text)*50,string.len(write_text)*100),"cb_sayanswer",write_text)
end

function cb_sayanswer (text)
	msg(""..chatbot.cb_name..": "..text.."")
end